import React from "react";
import { SectionHeader, SectionTitle } from "./styles/NavigationHeader";

const HeaderList = props => React.createElement(
    "li",
    null,
    React.createElement(
        "a",
        { className: "section-link", onClick: props.changeState },
        props.breadcrumb.label
    )
);

class NavigationHeader extends React.Component {
    changeState(breadcrumb) {
        if (breadcrumb.current) {
            return;
        }
        this.props.navigateToState && this.props.navigateToState(breadcrumb.state);
    }
    componentWillMount() {
        if (this.props.breadcrumbs) {
            this.props.breadcrumbs[this.props.breadcrumbs.length - 1]["current"] = true;
        }
    }
    render() {
        return React.createElement(
            SectionHeader,
            { className: "section-header" },
            this.props.breadcrumbs && React.createElement(
                "ul",
                null,
                this.props.breadcrumbs.map((breadcrumb, index) => React.createElement(HeaderList, { key: index, breadcrumb: breadcrumb, changeState: this.changeState.bind(this, breadcrumb) }))
            ),
            React.createElement(
                SectionTitle,
                null,
                this.props.title
            ),
            this.props.children
        );
    }
}

export default NavigationHeader;
//# sourceMappingURL=index.js.map