'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _icon = require('../../StyleComponents/icon');

var _icon2 = _interopRequireDefault(_icon);

var _Select = require('../../FormElements/Select/Select');

var _Select2 = _interopRequireDefault(_Select);

var _styles = require('./styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Created by sarunathan.s
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var TablePaginator = function (_React$Component) {
    _inherits(TablePaginator, _React$Component);

    function TablePaginator(props) {
        _classCallCheck(this, TablePaginator);

        var _this = _possibleConstructorReturn(this, (TablePaginator.__proto__ || Object.getPrototypeOf(TablePaginator)).call(this, props));

        _this.prevPage = _this.prevPage.bind(_this);
        _this.nextPage = _this.nextPage.bind(_this);
        _this.pageResize = _this.pageResize.bind(_this);
        var pageSize = _this.props.pageSize || 10;
        var pageNo = _this.props.pageNo || 1;
        _this.state = {
            startItem: pageSize * pageNo - pageSize + 1,
            pageSize: pageSize,
            endItem: pageSize > _this.props.totalItems ? _this.props.totalItems : pageSize,
            totalPages: Math.ceil(_this.props.totalItems / pageSize),
            totalItems: _this.props.totalItems,
            currentPage: pageNo
        };
        return _this;
    }

    _createClass(TablePaginator, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.props.onChange({
                pageNo: this.state.currentPage,
                pageSize: this.state.pageSize
            });
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if (!_lodash2.default.isEqual(nextProps, this.props)) {
                var pageSize = nextProps.pageSize;
                this.setState({
                    startItem: pageSize * (this.props.pageNo || this.state.currentPage) - pageSize + 1,
                    currentPage: nextProps.pageNo || this.state.currentPage,
                    pageSize: pageSize,
                    endItem: this.state.currentPage * pageSize > nextProps.totalItems ? nextProps.totalItems : this.state.currentPage * pageSize,
                    totalPages: Math.ceil(nextProps.totalItems / pageSize),
                    totalItems: nextProps.totalItems
                });
            }
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate(prevProps, prevState) {
            if (!_lodash2.default.isEqual(prevState, this.state) && this.props.onChange) {
                this.props.onChange({
                    pageNo: this.state.currentPage,
                    pageSize: this.state.pageSize
                });
            }
        }
    }, {
        key: 'prevPage',
        value: function prevPage() {
            var pageSize = this.props.pageSize;
            var prevPage = this.state.currentPage - 1;
            if (this.state.currentPage > 1) {
                this.setState(function (state) {
                    return {
                        startItem: pageSize * prevPage - pageSize + 1,
                        endItem: state.startItem - 1,
                        currentPage: --state.currentPage
                    };
                });
            }
        }
    }, {
        key: 'nextPage',
        value: function nextPage() {
            var pageSize = this.props.pageSize;
            var nextPage = this.state.currentPage + 1;
            if (this.state.currentPage < this.state.totalPages) {
                this.setState(function (state) {
                    return {
                        startItem: pageSize * nextPage - pageSize + 1,
                        endItem: state.endItem + state.pageSize > state.totalItems ? state.totalItems : state.endItem + state.pageSize,
                        currentPage: ++state.currentPage
                    };
                });
            }
        }
    }, {
        key: 'pageResize',
        value: function pageResize(e) {
            var pageSize = parseInt(e.target.value);
            this.setState({
                startItem: 1,
                endItem: pageSize > this.state.totalItems ? this.state.totalItems : pageSize,
                currentPage: 1,
                pageSize: pageSize,
                totalPages: Math.ceil(this.props.totalItems / pageSize)
            });
        }
    }, {
        key: 'render',
        value: function render() {
            return _react2.default.createElement(
                'div',
                { className: 'list-with-paginator' },
                this.props.children,
                _react2.default.createElement(
                    _styles.PaginatorContainer,
                    { className: 'paginator-container' },
                    _react2.default.createElement(
                        _styles.SelectContainer,
                        { className: 'select-container' },
                        _react2.default.createElement(
                            _Select2.default,
                            {
                                onChange: this.pageResize,
                                value: this.state.pageSize,
                                initialValue: this.props.pageSize,
                                className: 'page-size-selector'
                            },
                            _react2.default.createElement(
                                'option',
                                { value: 10 },
                                '10'
                            ),
                            _react2.default.createElement(
                                'option',
                                { value: 20 },
                                '20'
                            ),
                            _react2.default.createElement(
                                'option',
                                { value: 50 },
                                '50'
                            )
                        ),
                        ' ',
                        'Items per page'
                    ),
                    _react2.default.createElement(
                        'i',
                        { className: 'seperator' },
                        '|'
                    ),
                    _react2.default.createElement(
                        _styles.ItemsContainer,
                        { className: 'items-container' },
                        this.state.startItem,
                        ' - ',
                        this.state.endItem,
                        ' of',
                        ' ',
                        this.state.totalItems,
                        ' items'
                    ),
                    _react2.default.createElement(
                        _styles.PageContainer,
                        null,
                        this.state.currentPage,
                        ' of ',
                        this.state.totalPages,
                        ' ',
                        'pages'
                    ),
                    _react2.default.createElement(_icon2.default, {
                        onClick: this.prevPage,
                        className: 'fa fa-angle-left left-pagination'
                    }),
                    _react2.default.createElement(_icon2.default, {
                        onClick: this.nextPage,
                        className: 'fa fa-angle-right right-pagination'
                    })
                )
            );
        }
    }]);

    return TablePaginator;
}(_react2.default.Component);

TablePaginator.propTypes = {
    onChange: _propTypes2.default.func,
    children: _propTypes2.default.node,
    pageSize: _propTypes2.default.number,
    pageNo: _propTypes2.default.number,
    totalItems: _propTypes2.default.number
};

TablePaginator.defaultProps = {
    onChange: undefined,
    children: undefined,
    pageSize: 10,
    pageNo: 0,
    totalItems: 10
};

exports.default = TablePaginator;