"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.PanelTabs = exports.Panel = exports.Tab = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _PanelTabs = require("./styles/PanelTabs");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Created by manoraj.k on 17/08/17.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var Tab = exports.Tab = function (_React$Component) {
    _inherits(Tab, _React$Component);

    function Tab() {
        _classCallCheck(this, Tab);

        return _possibleConstructorReturn(this, (Tab.__proto__ || Object.getPrototypeOf(Tab)).call(this));
    }

    _createClass(Tab, [{
        key: "handleClick",
        value: function handleClick() {
            if (!this.props.isDisabled && this.props.currentPanel !== this.props.tabFor) {
                this.props.changePanel(this.props.tabFor);
            }
        }
    }, {
        key: "render",
        value: function render() {
            return _react2.default.createElement(
                "div",
                { className: (this.props.className || "") + "rc-tab", onClick: this.handleClick.bind(this) },
                this.props.children
            );
        }
    }]);

    return Tab;
}(_react2.default.Component);

var Panel = exports.Panel = function (_React$Component2) {
    _inherits(Panel, _React$Component2);

    function Panel() {
        _classCallCheck(this, Panel);

        return _possibleConstructorReturn(this, (Panel.__proto__ || Object.getPrototypeOf(Panel)).apply(this, arguments));
    }

    _createClass(Panel, [{
        key: "render",
        value: function render() {
            return _react2.default.createElement(
                "div",
                { className: (this.props.className || "") + "rc-panel" },
                this.props.children
            );
        }
    }]);

    return Panel;
}(_react2.default.Component);

var PanelTabs = exports.PanelTabs = function (_React$Component3) {
    _inherits(PanelTabs, _React$Component3);

    function PanelTabs() {
        _classCallCheck(this, PanelTabs);

        var _this3 = _possibleConstructorReturn(this, (PanelTabs.__proto__ || Object.getPrototypeOf(PanelTabs)).call(this));

        _this3.panels = [];
        _this3.tabs = [];
        _this3.state = {
            currentPanel: ""
        };
        return _this3;
    }

    _createClass(PanelTabs, [{
        key: "addTab",
        value: function addTab(tab) {
            this.tabs.push(tab);
        }
    }, {
        key: "addPanel",
        value: function addPanel(panel) {
            this.panels.push(panel);
        }
    }, {
        key: "changePanel",
        value: function changePanel(panelName) {
            this.setState({ currentPanel: panelName });
            this.props.onPanelChange && this.props.onPanelChange(panelName);
        }
    }, {
        key: "preparePanelsAndTabs",
        value: function preparePanelsAndTabs() {
            var self = this;
            this.tabs.length = 0;
            this.panels.length = 0;
            _react2.default.Children.forEach(this.props.children, function (child) {
                if (child.type == Tab) {
                    self.addTab.call(self, child);
                } else if (child.type == Panel) {
                    self.addPanel.call(self, child);
                }
            });
        }
    }, {
        key: "render",
        value: function render() {
            var _this4 = this;

            this.preparePanelsAndTabs.call(this);
            return _react2.default.createElement(
                _PanelTabs.PanelTabsContainer,
                { className: this.props.containerClass || "" },
                _react2.default.createElement(
                    _PanelTabs.HorizontalTabsContainer,
                    { className: this.props.tabContainerClass || "" },
                    this.tabs.map(function (tab, index) {
                        return _react2.default.cloneElement(tab, {
                            changePanel: _this4.changePanel.bind(_this4),
                            currentPanel: _this4.state.currentPanel
                        });
                    })
                ),
                this.panels.map(function (panel, index) {
                    return _react2.default.createElement(
                        "div",
                        { className: panel.props.name === _this4.state.currentPanel ? "show" : "hide" },
                        panel
                    );
                })
            );
        }
    }, {
        key: "componentDidMount",
        value: function componentDidMount() {
            if (this.props.default) {
                this.setState({ currentPanel: this.props.default });
            } else {
                this.setState({ currentPanel: this.panels[0].props.name });
            }
        }
    }, {
        key: "componentWillReceiveProps",
        value: function componentWillReceiveProps(nextProps) {
            if (nextProps.default !== this.props.currentPanel) {
                this.setState({ currentPanel: nextProps.default });
            }
        }
    }]);

    return PanelTabs;
}(_react2.default.Component);