'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _TabBar = require('./styles/TabBar');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Created by manoraj.k on 17/08/17.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var TabBar = function (_React$Component) {
    _inherits(TabBar, _React$Component);

    function TabBar() {
        _classCallCheck(this, TabBar);

        var _this = _possibleConstructorReturn(this, (TabBar.__proto__ || Object.getPrototypeOf(TabBar)).call(this));

        _this.state = {
            selected: 0
        };
        _this.onTabChange = _this.onTabChange.bind(_this);
        return _this;
    }

    _createClass(TabBar, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
            if (this.props.selected !== undefined) {
                this.setState({ selected: this.props.selected });
            } else {
                this.setState({ selected: 0 });
            }
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if (nextProps.selected !== undefined && nextProps.selected !== this.state.selected) {
                this.setState({ selected: nextProps.selected });
            }
        }
    }, {
        key: 'onTabChange',
        value: function onTabChange(index) {
            this.setState({ selected: index });
            if (this.props.onTabChange) {
                this.props.onTabChange(index);
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            return _react2.default.createElement(
                _TabBar.TabContainer,
                { className: 'tabbar-container' },
                this.props.tabBarName && _react2.default.createElement(
                    'span',
                    { className: 'tab-bar-name' },
                    this.props.tabBarName
                ),
                this.props.tabs.map(function (tab, index) {
                    return _react2.default.createElement(
                        _TabBar.Tab,
                        {
                            key: tab.label,
                            className: index === _this2.state.selected ? 'tab active' : 'tab',
                            onClick: function onClick() {
                                return _this2.onTabChange(index);
                            }
                        },
                        tab.label
                    );
                })
            );
        }
    }]);

    return TabBar;
}(_react2.default.Component);

exports.default = TabBar;


TabBar.propTypes = {
    selected: _propTypes2.default.number.isRequired,
    onTabChange: _propTypes2.default.func.isRequired,
    tabBarName: _propTypes2.default.string.isRequired,
    tabs: _propTypes2.default.arrayOf(_propTypes2.default.shape({
        label: _propTypes2.default.string.isRequired,
        value: _propTypes2.default.string.isRequired
    })).isRequired
};